local json = require("json")
local const = require("const")
local utils = require("utils")

utils_header = {}

local g_openapi_version = "2018-08-30"

local function _check_version(ver)
    if (ver == g_openapi_version) then
        return true
    else
        return false
    end
end

local function _check_signature_nonce(nonce, timestamp)


end

function  utils_header.check_uri_valid() 
    local args = ngx.req.get_uri_args()
    
    local version = args["Version"]
    local signatureNonce = args["SignatureNonce"]
    local timestampe = args["TimeStamp"]

end

function utils_header.check_public_boby_data()

    ngx.req.read_body()
    local args_json = ngx.req.get_body_data()
    if not args_json then
        local file_name = ngx.req.get_body_file()
        if file_name then
            local f = io.open(file_name, "r")
            if not f then
                utils.error_exit(503, "failed to read body")
            end
            args_json = f:read("*all")
            f:close()
        end
    end
    if(nil == args_json) then
        utils.error_exit(400, "request is invalid")
    end

    local ok, args = pcall(json.decode, args_json)
    if not ok then
        utils.error_exit(400)
    end

    local request = args["request"]
    if (request == nil) then
        utils.error_exit(400, "request is invalid")
    end

    local apiVer = request["apiVer"] 
    if (apiVer ~= "0.6") then
        utils.error_exit(400, "apiVer is invalid")
    end
    
    local params = args["params"]
    if(nil == params) then
        utils.error_exit(400, "params should not be null")
    end

    return params
end

return utils_header
